Index: PROJECT_CORE_MPI/MPI_HCL/BRANCHES/v2.0/NOC/CoreTypes.vhd
===================================================================
--- PROJECT_CORE_MPI/MPI_HCL/TRUNK/NOC/CoreTypes.vhd	(revision 101)
+++ PROJECT_CORE_MPI/MPI_HCL/BRANCHES/v2.0/NOC/CoreTypes.vhd	(revision 139)
@@ -9,5 +9,5 @@
 use IEEE.numeric_std.all;
 package CoreTypes is
-CONSTANT Word :POSITIVE:= 8;
+CONSTANT Word :POSITIVE:= 16;
 CONSTANT ADRLEN:POSITIVE:=16;
 CONSTANT LZFILL :std_logic_vector(2*Word-ADRLEN to 0):=(others=>'0');--indique le nombre de zero à utiliser pour completer le bus de données lorsque la longueur restante du bus d'adresse est inférueure à la largeur du bus de données
@@ -37,4 +37,6 @@
    array(natural range <>) of std_logic_vector( Word-1 downto 0);
 	
+	type Typ_PortIO8 is
+   array(natural range <>) of std_logic_vector( 7 downto 0);
 	type memory is 
 	array (natural range <>) of std_logic_vector(word-1 downto 0);
@@ -176,5 +178,7 @@
 end component SWITCH_GEN;
 -- déclaration des fonctions utilisées
- 
+ function wor (din : std_logic_vector) return std_logic;
+subtype resolved_or is wor std_logic;
+
  FUNCTION all_ones(s1:std_logic_vector) return std_logic; 
   --This function returns if the input vector has all ones and no zeros
@@ -330,5 +334,5 @@
 variable bit_image: String(1 to 3) := std_logic'image(L);
 begin
-return(bit_image(1 to 1));
+return(bit_image(2 to 2));
 end function image;
 
@@ -355,3 +359,13 @@
 return(RetVal);
 end function image;
+function wor (din : std_logic_vector) return std_logic is
+begin
+for i in din'range loop
+if (din(i)='1') then
+return din(i);
+end if;
+end loop;
+return '0';
+end function wor;
+
 end CoreTypes;
Index: PROJECT_CORE_MPI/MPI_HCL/BRANCHES/v2.0/NOC/Crossbar.vhd
===================================================================
--- PROJECT_CORE_MPI/MPI_HCL/TRUNK/NOC/Crossbar.vhd	(revision 101)
+++ PROJECT_CORE_MPI/MPI_HCL/BRANCHES/v2.0/NOC/Crossbar.vhd	(revision 139)
@@ -38,20 +38,20 @@
     Port ( clk : in  STD_LOGIC;
 			  reset : in  STD_LOGIC; --pour gérer le pipeline
-			  Port1_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port2_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port3_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port4_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-			  Port5_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port6_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port7_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port8_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-			  Port9_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port10_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port11_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port12_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-			  Port13_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port14_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port15_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port16_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
+			  Port1_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port2_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port3_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port4_in : in  STD_LOGIC_VECTOR (7 downto 0);
+			  Port5_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port6_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port7_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port8_in : in  STD_LOGIC_VECTOR (7 downto 0);
+			  Port9_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port10_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port11_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port12_in : in  STD_LOGIC_VECTOR (7 downto 0);
+			  Port13_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port14_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port15_in : in  STD_LOGIC_VECTOR (7 downto 0);
+           Port16_in : in  STD_LOGIC_VECTOR (7 downto 0);
 			  
 			  Port1_pulse_in : in std_logic;
@@ -89,20 +89,20 @@
 			  Port16_pulse_out : out std_logic;
 			  
-			  Port1_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port2_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port3_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port4_out : out  STD_LOGIC_VECTOR (Word-1 downto 0); 
-			  Port5_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port6_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port7_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port8_out : out  STD_LOGIC_VECTOR (Word-1 downto 0); 
-			  Port9_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port10_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port11_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port12_out : out  STD_LOGIC_VECTOR (Word-1 downto 0); 
-			  Port13_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port14_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port15_out : out  STD_LOGIC_VECTOR (Word-1 downto 0);
-           Port16_out : out  STD_LOGIC_VECTOR (Word-1 downto 0); 
+			  Port1_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port2_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port3_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port4_out : out  STD_LOGIC_VECTOR (7 downto 0); 
+			  Port5_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port6_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port7_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port8_out : out  STD_LOGIC_VECTOR (7 downto 0); 
+			  Port9_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port10_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port11_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port12_out : out  STD_LOGIC_VECTOR (7 downto 0); 
+			  Port13_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port14_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port15_out : out  STD_LOGIC_VECTOR (7 downto 0);
+           Port16_out : out  STD_LOGIC_VECTOR (7 downto 0); 
 			  
            Ctrl : in  STD_LOGIC_VECTOR (number_of_crossbar_ports*number_of_crossbar_ports downto 1)
Index: PROJECT_CORE_MPI/MPI_HCL/BRANCHES/v2.0/NOC/Def_Request.vhd
===================================================================
--- PROJECT_CORE_MPI/MPI_HCL/BRANCHES/v2.0/NOC/Def_Request.vhd	(revision 139)
+++ PROJECT_CORE_MPI/MPI_HCL/BRANCHES/v2.0/NOC/Def_Request.vhd	(revision 139)
@@ -0,0 +1,95 @@
+----------------------------------------------------------------------------------
+-- Company: 
+-- Engineer: 
+-- 
+-- Create Date:    17:58:09 04/07/2014 
+-- Design Name: 
+-- Module Name:    Def_Request - Behavioral 
+-- Project Name: 
+-- Target Devices: 
+-- Tool versions: 
+-- Description: 
+--
+-- Dependencies: 
+--
+-- Revision: 
+-- Revision 0.01 - File Created
+-- Additional Comments: 
+--
+----------------------------------------------------------------------------------
+library IEEE;
+use IEEE.STD_LOGIC_1164.ALL;
+use IEEE.STD_LOGIC_ARITH.ALL;
+use IEEE.STD_LOGIC_UNSIGNED.ALL;
+-- Uncomment the following library declaration if using
+-- arithmetic functions with Signed or Unsigned values
+--use IEEE.NUMERIC_STD.ALL;
+
+-- Uncomment the following library declaration if instantiating
+-- any Xilinx primitives in this code.
+--library UNISIM;
+--use UNISIM.VComponents.all;
+
+entity Def_Request is
+generic (NB_IO :positive:=4);
+    Port ( Req : in  STD_LOGIC_VECTOR (NB_IO**2 downto 1);
+           clk : in  STD_LOGIC;
+           reset : in  STD_LOGIC;
+			  fifo_full : in STD_LOGIC_VECTOR (NB_IO downto 1);
+           priority_rotation : in  STD_LOGIC_VECTOR (NB_IO downto 1);
+           grant : in  STD_LOGIC_VECTOR (NB_IO**2 downto 1);
+           request : out  STD_LOGIC_VECTOR (NB_IO**2 downto 1));
+end Def_Request;
+
+architecture Behavioral of Def_Request is
+constant NB_IO2 :positive:=NB_IO**2; -- le carré du nombre de ports d'E/S
+ Signal Fifo_out_full :  STD_LOGIC_VECTOR (NB_IO downto 1);
+ signal grant_latch : std_logic_vector(NB_IO2 downto 1); 
+ signal priority_rotation_en : std_logic; 
+signal req_grant,Grant_bak :  std_logic_vector(NB_IO2 downto 1):=(others=>'0');
+ signal Mreq :  std_logic_vector(NB_IO2 downto 1):=(others=>'1');
+
+begin
+ Req_grant<=(req and grant );
+ priority_rotation_en <= '1' when   unsigned(priority_rotation) = 2**NB_IO-1 else 	'0'; 
+ request<=req and mreq;
+--latch  qui memorise le signal grant pendant la transmission 
+ grant_latch_process : process(clk)
+  begin 
+  if rising_edge(clk) then 
+   if reset = '1' then 
+ 		grant_latch <= (others => '0');
+ 		Fifo_out_full<=(others => '0');
+ 	 elsif priority_rotation_en = '1' or unsigned(req_grant)=0 then 
+	   grant_latch <= Grant;
+	   Fifo_out_full<=fifo_full;
+  else
+    	 grant_latch <= Grant; 
+    	 Fifo_out_full<=fifo_full; 
+   end if; 
+   end if; 
+
+ end process; 
+ def_mreq: process(grant_latch,fifo_full)
+
+variable t:std_logic_vector(NB_IO2 downto 1):=(others=>'0');
+begin 
+    
+  for i in 0 to NB_IO2-1 loop
+    t(i+1):='0';
+    --sur le front montant de fifo_full sauver l'état Grant courant 
+    if fifo_full(i mod NB_IO+1)='1' and  fifo_out_full(i mod NB_IO+1)='0' then
+      Grant_bak(i+1)<= grant_latch(i+1);
+    elsif fifo_full(i mod NB_IO+1)='0' and  fifo_out_full(i mod NB_IO+1)='0'  then
+      Grant_bak(i+1)<='0';
+    end if;
+  for j in 0 to NB_IO-1 loop
+    t(i+1):=t(i+1) or grant_latch(j*NB_IO+1+i mod NB_IO) or fifo_out_full(i mod NB_IO+1);
+    
+  end loop;
+      mreq(i+1)<=not(t(i+1) ) or grant_latch(i+1)or grant_bak(i+1);    
+  end loop;
+end process;
+
+end Behavioral;
+
Index: PROJECT_CORE_MPI/MPI_HCL/BRANCHES/v2.0/NOC/FIFO_256_FWFT.vhd
===================================================================
--- PROJECT_CORE_MPI/MPI_HCL/TRUNK/NOC/FIFO_256_FWFT.vhd	(revision 101)
+++ PROJECT_CORE_MPI/MPI_HCL/BRANCHES/v2.0/NOC/FIFO_256_FWFT.vhd	(revision 139)
@@ -66,11 +66,11 @@
 attribute RAM_STYLE : string;
 
-type ram_type is array (2**(MPROOF+word)-1 downto 0) of std_logic_vector (Word-1 downto 0);
+type ram_type is array (2**(MPROOF+8)-1 downto 0) of std_logic_vector (Word-1 downto 0);
 	signal RAM: ram_type;
 	attribute RAM_STYLE of RAM: signal is "BLOCK";
 -- declaration des signeaux des compteurs
-signal push_address_counter: std_logic_vector(MPROOF+Word-1 downto 0);
-signal pop_address_counter : std_logic_vector(MPROOF+Word-1 downto 0);
-signal fifo_counter : std_logic_vector(MPROOF+Word-1 downto 0);
+signal push_address_counter: std_logic_vector(MPROOF+8-1 downto 0);
+signal pop_address_counter : std_logic_vector(MPROOF+8-1 downto 0);
+signal fifo_counter : std_logic_vector(MPROOF+8-1 downto 0);
 --autre signaux
 signal empty_signal: std_logic:='1';
@@ -105,7 +105,7 @@
 wr_en_signal <= wr_en and (not full_signal); -- la donnée est ignorée si le fifo est plein
 rd_en_signal <= rd_en and (not empty_signal);-- pas de lecture si le fifo est vide
-full_signal <= '1' when unsigned(fifo_counter) = 2**(MProof+word)-1 else
+full_signal <= '1' when unsigned(fifo_counter) = 2**(MProof+8)-1 else
 				   '0';
-near_full <= '1' when unsigned(fifo_counter) >= 2**(MProof+word)-5 else
+near_full <= '1' when unsigned(fifo_counter) >= 2**(MProof+8)-5 else
 				   '0';
 --empty_signal <= '1' when fifo_counter = "000000"  else
@@ -254,5 +254,5 @@
  -- processus de comptage des octets dans le fifo
  fifo_counter_process : process(clk_signal)
-variable count : std_logic_vector(MPROOF+word-1 downto 0):= (others=>'0');
+variable count : std_logic_vector(MPROOF+8-1 downto 0):= (others=>'0');
 begin
  if rising_edge(clk_signal) then
